﻿@using FourthMVCAppMy.DAL.Entities
@using Microsoft.AspNetCore.Identity
@model FourthMVCAppMy.Models.Ads.AdModel
@inject SignInManager<User> SignInManager
@inject UserManager<User> UserManager

@{
    ViewData["Title"] = "Details";
}

<h1>Подробно</h1>

<div>
    <hr />
    @switch (Model.RecordImageType)
    {
        case RecordImageType.Db:
            if (Model.Image != null && Model.Image.Length > 0)
            {
                <img style="width: 50%; height: 50%" src="data:image/jpeg;base64,@(Convert.ToBase64String(Model.Image))" />
            }
            break;
        case RecordImageType.Disk:
            if (!string.IsNullOrWhiteSpace(Model.ImagePath))
            {
                <img style="width: 50%; height: 50%" src="@Url.Content(Model.ImagePath)" />
            }
            break;
    }
    <dl class="row">
        <dt class="col-sm-6">
            @Html.DisplayNameFor(model => model.DateOfСreation)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.DateOfСreation)
        </dd>
        <dt class="col-sm-6">
            @Html.DisplayNameFor(model => model.Author)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.Author)
        </dd>
        <dt class="col-sm-6">
            @Html.DisplayNameFor(model => model.Title)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.Title)
        </dd>
        <dt class="col-sm-6">
            @Html.DisplayNameFor(model => model.Description)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.Description)
        </dd>
        <dt class="col-sm-6">
            @Html.DisplayNameFor(model => model.Price)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.Price)
        </dd>
        <dt class="col-sm-6">
            @Html.DisplayNameFor(model => model.ContactName)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.ContactName)
        </dd>
        <dt class="col-sm-6">
            @Html.DisplayNameFor(model => model.ContactPhone)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.ContactPhone)
        </dd>
    </dl>

    <table id="commentsTable" class="table">
        <tbody>
            @foreach (var item in Model.Comments)
            {
                <tr>
                    <td>
                        @Html.DisplayFor(modelItem => item.DateOfPublication)
                    </td>
                    <td>
                        @Html.DisplayFor(modelItem => item.Author)
                    </td>
                    <td>
                        @Html.DisplayFor(modelItem => item.CommentContent)
                    </td>
                    <td></td>
                </tr>
            }
        </tbody>
    </table>
</div>

<div id="gallery">
    @foreach (var galleryImage in Model.Images)
    {
        if (galleryImage.Image != null && galleryImage.Image.Length > 0)
        {
            <img style="width: 20%; height: 20%" src="data:image/jpeg;base64,@(Convert.ToBase64String(galleryImage.Image))" />
        }
    }
</div>

@if (SignInManager.IsSignedIn(User))
{
    <div><input type="button" id="addComment" class="btn-primary" value="Comment" /></div>
    <div id="commentForm" style="display: none">
        <div><textarea id="commentText" class="form-control"></textarea></div>
        <div><input type="button" id="sendComment" class="btn-primary" value="Send" /></div>
    </div>
}
else
{

}
<br />
@if (SignInManager.IsSignedIn(User))
{
    
        var galleryImageCreateModel = new GalleryImageCreateModel()
        {
            AdId = Model.Id
        };

    <partial name="_GalleryImagesPartial" model="@galleryImageCreateModel" />

}
else
{

}

<br />
<a asp-action="Index">Back to List</a>



@section Scripts
{
    <script>

        $('#addComment').click(function () {
            $('#commentForm').show();
            $('#addComment').hide();
        });

        $('#sendComment').click(function () {

            var commentContent = $('#commentText').val();
            var adId = '@Model.Id';
            $.ajax({
                url: '@Url.Action("AddComment", "Ad")',
                method: 'POST',
                data: { 'commentContent': commentContent, 'adId': adId },
                dataType: 'JSON',
                error: function (data) {
                    console.log(data);
                    alert('Error ' + data.status + "\n" + data.responseText);
                },
                success: function (data) {
                    $('#commentForm').hide();
                    $('#addComment').show();
                    var dateOfPublicationCell = "<td>" + data.dateOfPublication + "</td>";
                    var authorCell = "<td>" + data.author + "</td>";
                    var сommentContentCell = "<td>" + data.commentContent + "</td>";
                    var newRow = "<tr>" + dateOfPublicationCell + authorCell + сommentContentCell + "</tr>";
                    $('#commentsTable tbody').append(newRow);
                }
            });
        });

        $('#uploadImages').on('click', function () {
            var files = document.getElementById('uploadFile').files;
            if (files.length > 0) {
                var data = new FormData();
                for (var i = 0; i < files.length; i++) {
                    data.append("file" + i, files[i]);
                }

                $.ajax({
                    type: 'POST',
                    url: '@Url.Action("UploadAjax", "Ad")' + '/?adId=' + $('#adId').val(),
                    contentType: false,
                    processData: false,
                    data: data,
                    success: function (data) {
                        for (var i = 0; i < data.length; i++) {
                            var img = '<img style="width: 20%; height: 20%" src="data:image/jpeg;base64,' +
                                data[i].image +
                                '"/>';
                            $('#gallery').append(img);
                        }
                    },
                    error: function(data) {
                        alert(data);
                    }
                });
            }
        })

    </script>
}
